local name, addon = ...
local modName = "autogroup"
local message = {
  ["enUS"] = "Autoaccept invites",
  ["deDE"] = "Gruppeneinladungen annehmen"
}
local f
local accepted = false
addon['mhmods'] = addon['mhmods'] or {}

local function myGuild(unitname)
	for i=1,GetNumGuildMembers() do
		if(unitname == GetGuildRosterInfo(i)) then
			return true
		end
	end
	return false
end

local function myFriend(unitname)
	for i = 1, GetNumFriends() do
		if(unitname == GetFriendInfo(i)) then
			return true
		end
	end
	return false
end

local getPref = addon['MH_GetPref']
local options

local function watch(self)
	if(self['delay'] > GetTime()) then return end
	for index = 1, STATICPOPUP_NUMDIALOGS, 1 do
		local frame = _G["StaticPopup"..index];
		if( frame:IsShown() and (frame['which'] == "PARTY_INVITE") ) then 
			local btn = _G["StaticPopup"..index..(accepted and "Button1" or "Button2")]
			btn:GetScript("OnClick")(btn,'LeftButton',0)
		end
	end
	accepted = nil
	self:Hide()
end

addon['mhmods'][#addon['mhmods'] + 1] = {
	['name'] = modName,
	['message'] = message[GetLocale()] or message["enUS"],
	['init'] = function()
		f = CreateFrame("Frame")
		f['delay']=0
		f:Hide()
		f:SetScript("OnUpdate", watch)
		options = addon['MH_GetOptions']()
		local grp = addon:AddConfigMenu({['name'] = modName, ['order'] = 20},options)
		addon:AddConfigEntry("zz_MiscHelper","toggle","fugonly","Friends&Guild only",nil,1,nil,nil,nil,nil,grp)
	end,
	['events'] = { "PARTY_INVITE_REQUEST" },
	['onevent'] = function (event, arg1)
		if((getPref('fugonly') and (myFriend(arg1) or myGuild(arg1))) or not getPref('fugonly')) then
			accepted = true			
		end
		f['delay'] = GetTime() + 0.25
		f:Show()
	end,
}